<?php 

/** 

EasyPhpAlbum Lite Version 2.1.0 - PHP5
Copyright (c) 2008-2009 JF Nutbroek <jfnutbroek@gmail.com>

Permission to use, copy, modify, and/or distribute this software for any
purpose without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

**** INSTRUCTIONS ****

Upload this file together with photos to your webserver. That's all!

Create as many directories with photos as you need, you only need EasyPhpAlbum Lite once in the top directory:

- main directory           : Create a directory on your webserver, for example 'photoalbums'
  - index.php              : This file, upload it to the directory 'photoalbums'
  - albumdirectory 01      : A subdirectory in 'photoalbums' containing photos, for example 'album2008'
  -- albumsubdirectory 01  : A subdirectory in 'album2008' containing more photos, for example 'May2008'
  - albumdirectory 02      : A subdirectory in 'photoalbums' containing photos, for example 'album2009'
                           : etc. etc. 

Note: If you add new directories the menu needs to be reloaded by clicking 'Exit' (menu is cached for speed)

**** WHAT DOES IT DO? ****

- Your albums will be indexed and organized in a menu for easy navigation
- Thumbnails (smaller versions of the photos) will be saved when possible
- A visitor can select an album, browse through the thumbnails and click a thumbnail to view the larger photo
- A visitor can browse forward and backward through the album or start a simple slideshow

*/

$tableformat    = '4x4';                         // Display format amount of columns x rows for thumbnails
$thumbwidth     = 140;                           // Display size for the thumbnails in px
$browsing       = true;                          // Allow forward and backward browsing
$slideshow      = true;                          // Allow the slideshow option
$slideshowdelay = 4000;                          // Delay for slideshow in milliseconds
$buttoncolor    = '#99CCFF';                     // Color of the buttons
$show_name      = false;                         // Show filename below photo
$referralpage   = 'http://www.mywebmymail.com';  // Page to go to when visitor has disabled his browser referer

// EasyPhpAlbum Lite

session_start();

if (!isset($_SESSION['exit'])) {
        $_SESSION['exit'] = $referralpage;
	if (isset($_SERVER['HTTP_REFERER'])) {
                $thispage = strtolower('http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF']);
                if (substr(strtolower($_SERVER['HTTP_REFERER']), 0, strlen($thispage)) != $thispage)
                        $_SESSION['exit'] = $_SERVER['HTTP_REFERER'];     
        }
}

if (isset($_REQUEST['exit'])) {
        $url = $_SESSION['exit'];
        session_unset();
	session_destroy();
        header("Location: "  .  $url); 
	exit;
}

if (isset($_REQUEST['album'])) {
        $_SESSION['album'] = intval($_REQUEST['album']);
	unset($_SESSION['images']);
}

if (isset($_REQUEST['screenwidth'])) {
        $_SESSION['screenwidth'] = intval($_REQUEST['screenwidth']);
	if ($_SESSION['screenwidth']<1024) {$_SESSION['screenwidth']=1024;}
}

class easyphpthumbnail {
		
	public  $Thumbsize;			
	public  $Chmodlevel;	
	public  $Thumblocation;
	public  $Clipcorner;
	public  $Backgroundcolor;
	public  $Quality;
	private $image;			
	private $im;			
	private $thumb;			
	private $size;
	private $thumbx;				
	private $thumby;
	private $memsize;

	public function __construct() {
	
		$this->Thumbsize           =  140;
		$this->Chmodlevel          =  '0755';
		$this->Thumblocation       =  '';
		$this->Clipcorner          =  array(2, 15, 0, 1, 1, 1, 1);
		$this->Backgroundcolor     =  '#FAFAFA';
		$this->Quality             =  '90';
		$this->memsize             =  (integer) ini_get('memory_limit') * 1024 * 1024 * 0 . 85 - ($this->Thumbsize*$this->Thumbsize*4);
		
	}
	
	public function __destruct() {
        
		if(is_resource($this->im)) imagedestroy($this->im);
		if(is_resource($this->thumb)) imagedestroy($this->thumb);
        
	}
	
	public function Createthumb($filename = "unknown") {

		if (is_array($filename)) {
			foreach ($filename as $name) {
				$this->image = $name;
				$this->thumbmaker();
			}
		} else {
			$this->image = $filename;
			$this->thumbmaker();
		}
                
	}

	private function thumbmaker() {

		if ($this->loadimage()) {
			if ($this->Clipcorner[0] == 2) {$this->clipcornersround();}
			$this->createemptythumbnail();
			imagecopyresampled($this->thumb,$this->im, 0, 0, 0, 0, $this->thumbx,$this->thumby,imagesx($this->im),imagesy($this->im));
			$this->savethumb();
		}
                
	}
        
	private function loadimage() {
			
		try {
			if (file_exists($this->image)) {
				$this->size = GetImageSize($this->image);
				if ($this->memsize>0) {
						if (($this->size[0]*$this->size[1]*4)>$this->memsize) {return false;}
				}
				switch($this->size[2]) {
					case 1:
						if (imagetypes() & IMG_GIF) {$this->im = imagecreatefromgif($this->image);} 
						break;
					case 2:
						if (imagetypes() & IMG_JPG) {$this->im = imagecreatefromjpeg($this->image);} 
						break;
					case 3:
						if (imagetypes() & IMG_PNG) {$this->im = imagecreatefrompng($this->image);} 
						break;
					default:
						return false;
				}
				if (!$this->im) {return false;} else {return true;}
			} else {
				return false;	
			}
		} catch (Exception $e) {
			return false;
		}    
      
	}

	private function createemptythumbnail() {
        
		if ($this->size[0]>$this->size[1])
			$this->thumb = imagecreatetruecolor($this->Thumbsize, ceil($this->size[1]/($this->size[0]/$this->Thumbsize)));
		else
			$this->thumb = imagecreatetruecolor(ceil($this->size[0]/($this->size[1]/$this->Thumbsize)), $this->Thumbsize);
		$this->thumbx = imagesx($this->thumb);
		$this->thumby = imagesy($this->thumb);
		imagefilledrectangle($this->thumb, 0, 0, $this->thumbx,$this->thumby, imagecolorallocate($this->thumb,hexdec(substr($this->Backgroundcolor, 1, 2)),hexdec(substr($this->Backgroundcolor, 3, 2)),hexdec(substr($this->Backgroundcolor, 5, 2))));
        
	}

	private function clipcornersround() {
        
		$clipsize = floor($this->size[0]*($this->Clipcorner[1]/100));
		$clip_degrees = 90/max($clipsize, 1);
		$points_tl = array(0, 0);
		$points_br = array($this->size[0], $this->size[1]);
		$points_tr = array($this->size[0], 0);
		$points_bl = array(0, $this->size[1]);
		$bgcolor = imagecolorallocate($this->im,hexdec(substr($this->Backgroundcolor, 1, 2)),hexdec(substr($this->Backgroundcolor, 3, 2)),hexdec(substr($this->Backgroundcolor, 5, 2)));
		for ($i = 0;$i<$clipsize;$i++) {
			$x = $clipsize*cos(deg2rad($i*$clip_degrees));
			$y = $clipsize*sin(deg2rad($i*$clip_degrees));
			array_push($points_tl, $clipsize-$x);
			array_push($points_tl, $clipsize-$y);
			array_push($points_tr, $this->size[0]-$clipsize + $x);
			array_push($points_tr, $clipsize-$y);
			array_push($points_br, $this->size[0]-$clipsize + $x);
			array_push($points_br, $this->size[1]-$clipsize + $y);
			array_push($points_bl, $clipsize-$x);
			array_push($points_bl, $this->size[1]-$clipsize + $y);
		}
		array_push($points_tl, $clipsize,0);
		array_push($points_br, $this->size[0]-$clipsize, $this->size[1]);
		array_push($points_tr, $this->size[0]-$clipsize, 0);
		array_push($points_bl, $clipsize, $this->size[1]);
		imagefilledpolygon($this->im, $points_tl, count($points_tl)/2, $bgcolor);
		imagefilledpolygon($this->im, $points_bl, count($points_bl)/2, $bgcolor);          
		imagefilledpolygon($this->im, $points_tr, count($points_tr)/2, $bgcolor);          
		imagefilledpolygon($this->im, $points_br, count($points_br)/2, $bgcolor);
		imagerectangle($this->im, 0, 0, $this->size[0]-1, $this->size[1]-1, $bgcolor);

	}
        
	private function savethumb() {
        
		$this->image = substr($this->image, 0, strrpos($this->image, '.')) . ".jpg";
		@imagejpeg($this->thumb, $this->Thumblocation . basename($this->image), $this->Quality);
		if ($this->Chmodlevel != '') {@chmod($this->Thumblocation . basename($this->image), octdec($this->Chmodlevel));}
		imagedestroy($this->im);
		imagedestroy($this->thumb);
                
	}
  
}

// The page head
print <<<EOF

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1 . 0 Strict//EN" "http://www . w3 . org/TR/xhtml1/DTD/xhtml1-strict . dtd"><html xmlns = "http://www . w3 . org/1999/xhtml" lang = "en" xml:lang = "en">
<head><title>EasyPhpAlbum Lite &copy; 2008-2009</title>
<meta http-equiv = "Content-Type" content = "text/html;charset = utf-8" />

<style type="text/css">  
body {
    background-color   : #D0DEEE;
    margin             : 5px;
}
html { 
    height             : 100%; 
}
.contenttable {
    font-family        : Verdana, Helvetica, Arial, sans-serif;
    font-size          : 12px;
    color              : #555555;
    border-collapse    : collapse;
    background-color   : #FAFAFA;
    -moz-border-radius : 15px 15px 15px 15px;   
}
a:link,a:visited {
    color              : #555555;
    text-decoration    : none;
}
a:hover {
    text-decoration    : underline;
}
</style>

EOF;

// This scripts name
$scriptname = basename(__FILE__);
if ($scriptname == '') {$scriptname = 'index.php';}

if (isset($_REQUEST['page'])) {
	$page = intval($_REQUEST['page']);
} else {
	$page = 1;
}

if ($slideshow && isset($_REQUEST['slideshow'])) {
	echo "</head><body onload=\"setTimeout('nextslide();',$slideshowdelay);window.status='Slideshow active, click photo to stop';\" >\n";  
	echo "<script language=\"JavaScript\">\n";
	echo "function nextslide() {\n";
	$index=array_search($_REQUEST['photo'], $_SESSION['images']);
	if (key_exists($index + 1, $_SESSION['images'])) {
		echo "location.href='$scriptname?page=$page&slideshow=1&photo=" . urlencode($_SESSION['images'][$index + 1]) . "';\n";
	} else {
		echo "location.href='$scriptname?page=$page&slideshow=1&photo=" . urlencode($_SESSION['images'][0]) . "';\n";                
	}
	echo "}\n";
	echo "</script>\n";
} else {
	if(!isset($_SESSION['screenwidth'])) {
		echo "</head><body onload=\"location.href='$scriptname?screenwidth=' + screen.width;\">\n";
	} else {
		echo "</head><body>\n";
	}
}

echo "<table style=\"width : 100%;border : 0px;\" cellspacing=\"10px\" cellpadding=\"0px\"><tr><td style=\"width : 140px;vertical-align : top;\">\n";

 // Build the menu
if(!isset($_SESSION['menulite'])) {
	$_SESSION['menulite'] = array();
	$home = false;
	$homedir = getcwd();
	if ($dir = @opendir($homedir)) {
		while ($dirname = @readdir($dir)) {
			if (substr($dirname,0,1) != '.' && is_dir($dirname) && $dirname != 'thumbs') {
				$_SESSION['menulite'][] = array(str_replace('.', '', $dirname), $dirname);
				photoalbums($homedir . '/' . $dirname . '/');
			} else if (substr($dirname,0,1) != '.' && !is_dir($dirname) && $dirname != $scriptname) {
				$extension = strtolower(substr($dirname, strrpos($dirname,'.') + 1, strlen($dirname)));
				if ($extension == 'jpg' || $extension == 'jpeg' || $extension == 'png' || $extension == 'gif')
					$home = true;
			}
		}
	}
	if ($home && count($_SESSION['menulite']) > 0) {
		array_unshift($_SESSION['menulite'], array(basename(dirname(__FILE__)), './'));
	}
}

// Print the menu
echo "<table class=\"contenttable\" style=\"width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td>&nbsp;</td></tr>\n";
foreach($_SESSION['menulite'] as $key => $url) {
	if (substr($url[0],0,1)!='.') {echo "<tr><td style=\"text-align : left;\">";}
	if ($_SESSION['album'] == $key)
		echo "<span style=\"padding-left : 15px;\"><a href=\"$scriptname?album=$key\" style=\"text-decoration : underline;\">$url[0]</a></span>";
	else
		echo "<span style=\"padding-left : 15px;\"><a href=\"$scriptname?album=$key\">$url[0]</a></span>";
	if (key_exists($key + 1, $_SESSION['menulite'])) {
		$nextmenuitem = $_SESSION['menulite'][$key + 1];
		if (substr($nextmenuitem[0],0,1)=='.') {echo "<br />";} else {echo "</td></tr><tr><td>&nbsp;</td></tr>\n";}
	} else {
		echo "</td></tr>\n"; 
	}
}
echo "<tr><td>&nbsp;</td></tr><tr><td style=\"text-align : left;padding-left : 15px;\"><a href=\"$scriptname?exit=1\">Exit</a></td></tr>\n";
echo "<tr><td>&nbsp;</td></tr><tr><td style=\"text-align : center;font-size : 9px;\" nowrap=\"nowrap\">&copy; EasyPhpAlbum Lite</td></tr>\n"; 
echo "</table>\n";

// Insert a banner below the menu, place the code here
// echo "<table style=\"width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td>\n";
// Banner code
// echo "</tr></td></table>\n";

// Main content
echo "</td><td style=\"vertical-align : top;\">\n";

// Determine which album to show
if (count($_SESSION['menulite']) == 0) {
	$album = './';
} else {
	if (isset($_SESSION['album'])) {
		if (key_exists($_SESSION['album'], $_SESSION['menulite'])) {
			$albumurl = $_SESSION['menulite'][$_SESSION['album']];
			$album = $albumurl[1];
		}
	} else {
		$albumurl = $_SESSION['menulite'][0];
		$album = $albumurl[1];  
	}
}

if (!isset($_SESSION['images'])) {
	// Read all image files in selected album
	$_SESSION['images'] = array();
	$newthumbs = array();
	if ($dir = @opendir($album)) {
		while ($filename = @readdir($dir)) {
			if (substr($dirname, 0, 1) != '.' && !is_dir($filename)) {
				$extension = strtolower(substr($filename, strrpos($filename,'.') + 1, strlen($filename)));
				if ($extension == 'jpg' || $extension == 'jpeg' || $extension == 'png' || $extension == 'gif') {
					$_SESSION['images'][] = $filename;
					if (!file_exists($album . '/thumbs/' . substr($filename, 0, strrpos($filename, '.')) . ".jpg"))
						$newthumbs[] = $album . '/' . $filename;
				}
			}
		}
	}

	// Save new thumbs if required
	if (count($newthumbs) > 0) {
		$thumb = new easyphpthumbnail;
		$thumb -> Thumblocation = $album  .  '/thumbs/';
		if (!file_exists($thumb->Thumblocation)) {
			@mkdir($thumb->Thumblocation);
			@chmod($thumb->Thumblocation, octdec($thumb->Chmodlevel));
		}
		$thumb -> Createthumb($newthumbs);
	}	
}

// The main table
 echo "<table class=\"contenttable\" style=\"width : 100%;\"><tr><td style=\"text-align : center;vertical-align : middle;\">\n";

// Display the thumbs or photo
$column = 0;
$table = explode('x', $tableformat);
$tablesize = $table[0] * $table[1];
if (isset($_REQUEST['photo'])) {
	$photo = basename($_REQUEST['photo']);
} else {
	$photo = '';
}
echo "<table style=\"width : 100%;\">\n";
if ($photo == '') {
	// Display thumbnails
	if (count($_SESSION['images']) > 0 && count($_SESSION['images']) >= ($page-1)*$tablesize) {
		foreach($_SESSION['images'] as $key => $image) {
			if ($key >= ($tablesize*($page-1)) && $key < ($tablesize*$page)) {
				if ($column == 0) {
					echo "<tr>";
				}
				if (file_exists($album  .  '/thumbs/' . substr($image, 0, strrpos($image,'.') + 1)  . 'jpg')) {
					echo "<td><a href=\"$scriptname?page=$page&amp;photo="  .  urlencode($image)  .  "\"><img src=\""  .  $album  .  '/thumbs/' . substr($image, 0, strrpos($image,'.') + 1)  . 'jpg' .  "\" style=\"border : 0px;\" alt=\"$image\" title=\"Click to enlarge\" /></a></td>";
				} else {
                                        $size = @getimagesize($album  .  "/$image");
					if ($size[0] > $size[1])
						$width = $thumbwidth . 'px';
					else
						$width = ceil($size[0]/($size[1]/$thumbwidth)) . 'px';
					echo "<td><a href=\"$scriptname?page=$page&amp;photo="  .  urlencode($image)  .  "\"><img src=\""  .  $album  .  "/$image"  .  "\" style=\"border : 0px;width : $width;\" alt=\"$image\" title=\"Click to enlarge\" /></a></td>";
				}
				$column += 1;
				if ($column == $table[0]) {
					$column = 0;
					echo "</tr>\n";
				}
			}
		}
		$lastpageimages = count($_SESSION['images'])-($tablesize*($page-1));
		if ($page == ceil(count($_SESSION['images'])/$tablesize) && $lastpageimages < $table[0]) {
			echo "</tr></table>\n";		
		} else if ($column < $table[0] && $column > 0) {
			echo str_repeat('<td>&nbsp;</td>', $table[0]-$column)  .  "</tr>\n"  .  "</table>\n";
		} else {
			echo "</table>\n";
		}
	} else {
		echo "<tr><td style=\"text-align : center;vertical-align : middle;height : 100px;\">No images found!</td></tr></table>\n";
	}
} else {
	// Display full size photo
	if (in_array($photo, $_SESSION['images'])) {
		// Getimagesize is slow but required to display photos within the current screenwidth
		$size=getimagesize($album.'/'.$photo);
		if ($size[0]>($_SESSION['screenwidth']-360)) {
			$width='width : ' . ($_SESSION['screenwidth']-360) .'px';
		} else {
			$width="width : $size[0]px";
		}
		$index=array_search($photo, $_SESSION['images']);
		if ($browsing && !isset($_REQUEST['slideshow']) && key_exists($index + 1, $_SESSION['images'])) {
			$nextf="onmouseover=\"this.bgColor='$buttoncolor';this.style.cursor='pointer';\" title=\"browse forward\" onclick=\"location.href=('$scriptname?page=$page&amp;photo="  .  urlencode($_SESSION['images'][$index + 1])  .  "');\"";
                        $nextfs="style=\"width : 30px; border : 1px solid $buttoncolor;\"";
                } else {
			$nextf='';
                        $nextfs='style="width : 30px; border : 0px;"';
		}
		if ($browsing && !isset($_REQUEST['slideshow']) && key_exists($index - 1, $_SESSION['images'])) {
			$nextb="onmouseover=\"this.bgColor='$buttoncolor';this.style.cursor='pointer';\" title=\"browse backward\" onclick=\"location.href=('$scriptname?page=$page&amp;photo="  .  urlencode($_SESSION['images'][$index - 1])  .  "');\"";
                        $nextbs="style=\"width : 30px; border : 1px solid $buttoncolor;\"";
                } else {
			$nextb='';
                        $nextbs='style="width : 30px; border : 0px;"';
		}		
		echo "<tr><td>\n";
		echo "<table style=\"width : 100%;\"><tr><td style=\"vertical-align : top; text-align : center;\">\n";
		echo "<table $nextbs ><tr><td style=\"height : 25px; text-align : center;\" $nextb onmouseout=\"this.bgColor='#FAFAFA';\">&nbsp;</td></tr></table>\n";
		echo "</td><td style=\"text-align : center;width : 100%;\">\n";
		echo "<a href=\"$scriptname?page=$page\"><img src=\""  .  $album  .  '/'  .  basename($photo)  .  "\" style=\"border : 0px; $width;\" alt=\"$photo\" title=\"Click to go back\" /></a>\n";
		if ($show_name)
			echo "<br /><br />"  .  substr($photo, 0, strrpos($photo, '.'));
		echo "</td><td style=\"vertical-align : top; text-align : center;\">\n";
		echo "<table $nextfs ><tr><td style=\"height : 25px; text-align : center;\" $nextf onmouseout=\"this.bgColor='#FAFAFA';\">&nbsp;</td></tr></table>\n";
		echo "</td></tr></table>\n";
		echo "</td></tr>\n";
                // Slideshow button
		if ($slideshow && !isset($_REQUEST['slideshow']))
			echo "<tr><td style=\"text-align : left;padding-left : 5px;\"><table style=\"width : 30px; border : 1px solid $buttoncolor;\"><tr><td style=\"height : 25px; text-align : center;\" onmouseover=\"this.bgColor='$buttoncolor';this.style.cursor='pointer';\" title=\"start slideshow\" onclick=\"location.href=('$scriptname?page=$page&amp;slideshow=1&amp;photo="  .  urlencode($photo)  .  "');\" onmouseout=\"this.bgColor='#FAFAFA';\">&nbsp;</td></tr></table></td></tr>\n";  
		echo "</table>\n";
	} else {
		echo "<tr><td style=\"text-align : center;vertical-align : middle;height : 100px;\">No image found!</td></tr></table>\n";	
	}
}

// Display the amount of pages
if ($tablesize < count($_SESSION['images']) && $photo == '') {
	echo "<table style=\"width : 100%;\">\n";
	echo "<tr><td style=\"text-align : center;\">";
	for ($i = 1; $i <= ceil(count($_SESSION['images']) / $tablesize); $i++) {
		if ($page == $i) {
			echo " <a href=\"$scriptname?page=$i\" style=\"text-decoration : underline;\">$i</a>";} else {echo " <a href=\"$scriptname?page=$i\">$i</a>";
		}
	}
	echo "</td></tr>\n";
	echo "</table>\n";
}

// Close the main table
echo "</td></tr></table>\n";

// Insert a banner below the main content, place the code here
// echo "<table style=\"width : 100%;\" cellspacing=\"0\" cellpadding=\"0\"><tr><td>\n";
// Banner code
// echo "</tr></td></table>\n";

// End of page
echo "</td></tr></table>\n";
echo "</body></html>\n";

// Functions
function photoalbums($path) {

	global $homedir;
	if ($dir = @opendir($path)) {
		while ($dirname = @readdir($dir)) {
			if (substr($dirname,0,1) != '.' && is_dir($path . $dirname) && $dirname != 'thumbs') {
				$_SESSION['menulite'][] = array(str_repeat('.', substr_count($path . $dirname, '/', strlen($homedir))-1) . str_replace('.', '', $dirname), substr($path, strlen($homedir) + 1) . $dirname);
				photoalbums($path . $dirname . '/');
			}
		}
	}  

}

?>
